<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "config.php" );
require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

foreach ( $_POST as $postvar => $postval )
{
	$$postvar = $postval;
}

if ( trim( $fid ) == NULL )
{
	die( "No forum selected." );
}

$userdata = array();
$userdata = AuthenticateUser();
if ( $userdata["authstatus"] != 1 )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

$isadmin = CheckUserAdmin();

GenerateHeader( "EverList - Forum Moderation", TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

$profiledata = array();
$profiledata = $topdata["profiledata"];

$moderations = array();
$moderations = GetWords( $profiledata["moderatedforumids"] );

$ismoderator = FALSE;
foreach ( $moderations as $modkey => $modval )
{
	if ( $modval == $fid )
	{
		$ismoderator = TRUE;
		break;
	}
}

if ( $isadmin == FALSE && $ismoderator == FALSE )
{
	print "You are not authorized to moderate this forum.";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

$forumdata = array();
$forumdata = LoadForum( $fid );

if ( $forumdata["success"] == FALSE )
{
	print "Invalid fid '$fid'!  No such forum exists.";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

if ( $formstage == 1 && $isadmin == TRUE 
	&& strcmp( $deleteforum, "** DELETE THIS FORUM! **" ) == 0 )
{
	$query = "delete from forums where fid='$fid'";
	$resulttl4 = mysql_query( $query ) or die( "Query '$query' failed for resulttl4 in advancededit.php : " . mysql_error() );
	
	header( "Location: moderate.php?msg=Forum " . $forumdata["fname"] . " DELETED Successfully!" );
	die();
}

if ( $formstage == 1 )
{
	if ( trim( $s_fname ) == NULL )
	{
		print "<h3 style=\"color: red\">You must specify a forum name!</h3>";
		$formstage = 0;
	}
	
	$s_fname = addslashes( $s_fname );
	
	$query = "select fname from forums where fname='$s_fname' AND fid<>'$fid'";
	$resulttl2 = mysql_query( $query ) or die( "Query '$query' failed for resulttl2 in advancededit.php : " . mysql_error() );
	
	$dupfound = FALSE;
	while ( $line = mysql_fetch_array( $resulttl2, MYSQL_ASSOC ) )
	{
		$dupfound = TRUE;
		break;
	}
	
	if ( $dupfound == TRUE )
	{
		print "<h3 style=\"color: red\">A forum by that name already exists!</h3>";
		$formstage = 0;
	}
}

if ( $formstage == 1 )
{
	$moderatoruserids = NULL;
	foreach ( $_POST as $postvar => $postval )
	{
		if ( strcasecmp( substr( $postvar, 0, 5 ), "s_mod" ) == 0 )
		{
			if ( $moderatoruserids != NULL )
			{
				$moderatoruserids .= "|";
			}
			
			$moderatoruserids .= substr( $postvar, 5, strlen( $postvar ) - 5 );
		}
	}
	
	if ( trim( $s_maxpostsperday ) == NULL || !is_numeric( $s_maxpostsperday ) )
	{
		$s_maxpostsperday = 0;
	}
	if ( trim( $s_maxpostsperhour ) == NULL || !is_numeric( $s_maxpostsperhour ) )
	{
		$s_maxpostsperhour = 0;
	}
	
	$query = "update forums set fname='" . addslashes( $s_fname ) . "', ";
	$query .= "fdescription='" . addslashes( $s_fdescription ) . "', ";
	$query .= "ispublic='$s_ispublic', isclosed='$s_isclosed', ";
	$query .= "subscriptionpolicy='$s_subscriptionpolicy', ";
	$query .= "fmoderatoruserids='$moderatoruserids', fvisible='$s_fvisible', ";
	$query .= "fdigestdefault='$s_fdigestdefault', maxpostsperday='$s_maxpostsperday', ";
	$query .= "maxpostsperhour='$s_maxpostsperhour'";
	$query .= " where fid='$fid'";
	$resulttl3 = mysql_query( $query ) or die( "Query '$query' failed for resulttl3 in advancededit.php : " . mysql_error() );
	
	header( "Location: moderate.php?msg=Changes to " . $forumdata["fname"] . " Saved Successfully!" );
	die();
}
else if ( $formstage == 2 )
{
	$inviteusers = array();
	$inviteusers[0] = 0;
	
	foreach ( $_POST as $postvar => $postval )
	{
		if ( strcmp( substr( $postvar, 0, 3 ), "inv" ) == 0 
			&& strlen( $postvar ) > 3 )
		{
			$inviteusers[0]++;
			$inviteusers[$inviteusers[0]] = array();
			$inviteusers[$inviteusers[0]]["userdata"] = array();
			$inviteusers[$inviteusers[0]]["userdata"] = LoadUser( substr( $postvar, 3, strlen( $postvar ) - 3 ) );
			$inviteusers[$inviteusers[0]]["profiledata"] = array();
			$inviteusers[$inviteusers[0]]["profiledata"] = LoadProfile( $inviteusers[$inviteusers[0]]["userdata"]["userid"] );
		}
	}
	
	for ( $invloop = 1; $invloop <= $inviteusers[0]; $invloop++ )
	{
		$invitedforumids = $inviteusers[$invloop]["profiledata"]["invitedforumids"];
		$toemail = $inviteusers[$invloop]["userdata"]["email"];
		
		if ( $invitedforumids != NULL )
		{
			$invitedforumids .= "|";
		}
		$invitedforumids .= $fid;
		
		$query = "update profiles set invitedforumids='$invitedforumids'";
		$query .= " where userid='" . $inviteusers[$invloop]["profiledata"]["userid"] . "'";
		$resulttl5 = mysql_query( $query ) or die ( "Query '$query' failed for resulttl5 in advancededit.php : " . mysql_error() );
		
		$subject = "EverList Forum Invitation!";
		
		$msgbody = "Dear " . $inviteusers[$invloop]["profiledata"]["fullname"] . ",";
		$msgbody .= "\r\n\r\n";
		$msgbody .= "You have been invited to subscribe to the EverList forum, \"";
		$msgbody .= $forumdata["fname"];
		$msgbody .= "\", by the following moderator of that forum:\r\n\r\n";
		$msgbody .= "Name:  " . $profiledata["fullname"] . "\r\n";
		$msgbody .= "Email:  " . $userdata["email"] . "\r\n\r\n";
		$msgbody .= "You may now subscribe to this forum by visiting the following URL:";
		$msgbody .= "\r\n\r\n";
		$msgbody .= $siteurl . "/subscribe.php?fid=$fid\r\n\r\n";
		$msgbody .= "--EverList Mailer";
		
		$mailresult = mail( $toemail, $subject, $msgbody, 
			// Email header
			"From: " . $mailfrom . "\r\n" 
			. "Reply-To: " . $replyto . "\r\n" 
			. "Content-type: text/plain\r\n" 
			. "X-mailer: PHP/" . phpversion() );
	}
	
	header( "Location: moderate.php?msg=Invitations for " . $forumdata["fname"] . " Sent to " . $inviteusers[0] . " Users Successfully!" );
	die();
}

?>
<table border="0" cellpadding="0" cellspacing="0" width="750">
<tr>
<td><img src="images/space1px.gif" width="15" height="1" alt="" /></td>
<td>
<table border="0" cellpadding="0" cellspacing="0">
<tr>

<td><img src="images/space1px.gif" width="20" height="1" alt="" /></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="control_panel.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Your Profile</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="changepassword.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Change Password</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
<td bgcolor="#40AA40"><a href="subscriptions.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Subscriptions</b></span></a></td>
<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>

<?php
if ( trim( $profiledata["moderatedforumids"] ) != NULL 
	|| $isadmin == TRUE )
{
	?>
	<td align="right"><img src="images/subsel_left.gif" width="7" height="17" alt="" /></td>
	<td bgcolor="#90EE90"><a href="moderate.php"><span style="font-size: 8pt; color: darkgreen; font-family: Courier New"><b>Manage Forums</b></span></a></td>
	<td align="left"><img src="images/subsel_right.gif" width="7" height="17" alt="" /></td>
	
	<?php
}

if ( $isadmin == TRUE )
{
	?>
	<td align="right"><input type="image" width="7" height="17" border="0" src="images/subunsel_left.gif" name="tab_advanced"></td>
	<td bgcolor="#40AA40"><a href="manageusers.php"><span style="font-size: 8pt; color: white; font-family: Courier New"><b>Manage Users</b></span></a></td>
	<td align="left"><input type="image" width="7" height="17" border="0" src="images/subunsel_right.gif" name="tab_advanced"></td>
	
	<?php
}

if ( $forumdata["fvisible"] == 1 )
{
	$vischecked1 = " checked";
	$vischecked2 = NULL;
}
else
{
	$vischecked1 = NULL;
	$vischecked2 = " checked";
}

$moderators = array();
$moderators = GetWords( $forumdata["fmoderatoruserids"] );

?>
</tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="735">
<tr>
<td width="8"><img src="images/sub_topleft.gif" width="8" height="8" alt="" /></td>
<td bgcolor="#90EE90"><img src="images/space1px.gif" width="716" height="1" alt="" /></td>
<td width="11"><img src="images/sub_topright.gif" width="11" height="8" alt="" /></td>
</tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="735">

<tr>
<td bgcolor="#90EE90"><img src="images/space1px.gif" width="8" height="1" alt="" /></td>
<td bgcolor="#90EE90" align="center">


<h3 style="color: #005000">Edit Forum: &nbsp;<span style="color: blue"><?php print $forumdata["fname"]; ?></span></h3>

<form name="cform" id="cform" action="advancededit.php" method="POST">

<input type="hidden" name="formstage" id="formstage" value="1" />
<input type="hidden" name="fid" id="fid" value="<?php print $fid; ?>" />

<table border="0" cellspacing="2" cellpadding="2" width="90%">
<tr>
<td align="right">
<b>Forum Name:</b> &nbsp;
</td>
<td>
<input type="text" name="s_fname" id="s_fname" maxlength="22" size="30" />
</td>
</tr>
<tr>
<td align="right">
<b>Brief Description:</b> &nbsp;
</td>
<td>
<input type="text" name="s_fdescription" id="s_fdescription" maxlength="250" size="55" />
</td>
</tr>
<tr>
<td align="right">
<b>Max Posts Per Hour:</b> &nbsp;
</td>
<td>
<input type="text" name="s_maxpostsperhour" id="s_maxpostsperhour" maxlength="3" size="1" /> 
<span style="font-size: 10pt; color: navy">0 = Unlimited</span>
</td>
</tr>
<tr>
<td align="right">
<b>Max Posts Per Day:</b> &nbsp;
</td>
<td>
<input type="text" name="s_maxpostsperday" id="s_maxpostsperday" maxlength="3" size="1" /> 
<span style="font-size: 10pt; color: navy">0 = Unlimited</span>
</td>
</tr>
<tr>
<td align="right">
<b>Public Forum?</b> &nbsp;
</td>
<td>
<select name="s_ispublic" id="s_ispublic">
<option value="1">All Users Can View/Post</option>
<option value="2">Only Subscribed Users May Post, But Everyone Can View</option>
<option value="3">Nobody Can View or Post Unless Subscribed</option>
</select>
</td>
</tr>
<tr>
<td align="right">
<b>Closed Forum?</b> &nbsp;
</td>
<td>
<select name="s_isclosed" id="s_isclosed">
<option value="0">Open</option>
<option value="1">CLOSED</option>
<option value="2">No New Posts</option>
<option value="3">Closed, EXCEPT for Admins</option>
<option value="4">No New Posts, EXCEPT for Admins</option>
</select>
</td>
</tr>
<tr>
<td align="right">
<b>Visible to Non-Subscribers?</b> &nbsp;
</td>
<td>
<input type="radio" name="s_fvisible" id="s_fvisible" value="1"<?php print $vischecked1; ?> /> Yes &nbsp;
<input type="radio" name="s_fvisible" id="s_fvisible" value="0"<?php print $vischecked2; ?> /> No
</td>
</tr>
<tr>
<td align="right">
<b>Subscription Policy:</b> &nbsp;
</td>
<td>
<select name="s_subscriptionpolicy" id="s_subscriptionpolicy">
<option value="0">CLOSED to New Subscriptions</option>
<option value="1" selected>Allow & Approve New Subscriptions Automatically</option>
<option value="2">New Subscription Requests Require Approval</option>
<option value="3">New Subscriptions by Invitation Only</option>
</select>
</td>
</tr>
<tr>
<td align="right">
<b>"Recommended" Digest Setting:</b> &nbsp;
</td>
<td>
<select name="s_fdigestdefault" id="s_fdigestdefault">
<option value="0">No Digest Emails</option>
<option value="1" selected>Receive All Digest Emails</option>
<option value="2">Digest Email for Topic-Starter Only</option>
<option value="3">Digest Email for Topic-Starter + 1 Reply Notification</option>
</select>
</td>
</tr>
<tr>
<td align="right" valign="top">
<b>Assign Moderators:</b> &nbsp;
</td>
<td>
<?php

$query = "select users.userid, profiles.fullname, users.email from users, profiles where users.userid=profiles.userid AND ( users.status='ACTIVE' OR users.status='ADMIN' ) ORDER BY profiles.fullname ASC";
$resulttl1 = mysql_query( $query ) or die( "Query '$query' failed for resulttl1 in advancededit.php : " . mysql_error() );

while ( $line = mysql_fetch_array( $resulttl1, MYSQL_ASSOC ) )
{
	$sqloop = 0;
	$userid = NULL;
	$username = NULL;
	$email = NULL;
	foreach ( $line as $col_value )
	{
		$fieldname = mysql_field_name( $resulttl1, $sqloop );
		$$fieldname = $col_value;
		$sqloop++;
	}
	if ( trim( $userid ) == NULL || trim( $fullname ) == NULL 
		|| trim( $email ) == NULL || !is_numeric( $userid ) )
	{
		continue;
	}
	$checked = NULL;
	foreach ( $moderators as $modkey => $modval )
	{
		if ( $modkey == 0 )
		{
			continue;
		}
		
		if ( $modval == $userid )
		{
			$checked = " checked";
			break;
		}
	}
	?>
	<input type="checkbox" name="s_mod<?php print $userid; ?>" id="s_mod<?php print $userid; ?>"<?php print $checked; ?> /> 
	<a href="viewprofile.php?userid=<?php print $userid; ?>"><?php print $fullname . " (" . $email . ")"; ?></a>
	<br />
	<?php
}

?>
</td>
</tr>
</table>

<br />

<input type="submit" name="submitform" value="Save Changes" />

<?php
if ( $isadmin == TRUE )
{
	?>
	<br />
	<br />
	<br />
	
	<input type="submit" name="deleteforum" value="** DELETE THIS FORUM! **" style="background-color: red; color: yellow; font-weight: bold" onClick="return confirmDelete('<?php print $forumdata["fname"]; ?>');" />
	<?php
}

?>
</form>

<script language="JavaScript">
document.cform.s_fname.value="<?php print $forumdata["fname"]; ?>";
document.cform.s_fdescription.value="<?php print $forumdata["fdescription"]; ?>";
document.cform.s_maxpostsperhour.value="<?php print $forumdata["maxpostsperhour"]; ?>";
document.cform.s_maxpostsperday.value="<?php print $forumdata["maxpostsperday"]; ?>";
document.cform.s_ispublic.value="<?php print $forumdata["ispublic"]; ?>";
document.cform.s_isclosed.value="<?php print $forumdata["isclosed"]; ?>";
document.cform.s_subscriptionpolicy.value="<?php print $forumdata["subscriptionpolicy"]; ?>";
document.cform.s_fdigestdefault.value="<?php print $forumdata["fdigestdefault"]; ?>";
</script>

<hr width="100%" />

<h3 style="color: #005000">Invite Users</h3>

<?php

$profilesdata = array();
$profilesdata = LoadProfiles();

$eligibleinvites = array();
$eligibleinvites[0] = 0;

foreach ( $profilesdata as $pkey => $pval )
{
	if ( $pkey == 0 )
	{
		continue;
	}
	
	$subfound = FALSE;
	$subs = array();
	$subs = GetWords( $pval["subscribedforumids"] );
	foreach ( $subs as $skey => $sval )
	{
		if ( $skey == 0 )
		{
			continue;
		}
		
		if ( $sval == $fid )
		{
			$subfound = TRUE;
			break;
		}
	}
	
	if ( $subfound == FALSE )
	{
		$invites = array();
		$invites = GetWords( $pval["invitedforumids"] );
		foreach ( $invites as $ikey => $ival )
		{
			if ( $ikey == 0 )
			{
				continue;
			}
			
			if ( $ival == $fid )
			{
				$subfound = TRUE;
				break;
			}
		}
	}
	
	if ( $subfound == FALSE )
	{
		$eligibleinvites[0]++;
		$eligibleinvites[$eligibleinvites[0]] = array();
		$eligibleinvites[$eligibleinvites[0]] = $profilesdata[$pkey];
	}
}

if ( $eligibleinvites[0] == 0 )
{
	print "There are no users who haven't already subscribed or been invited to this forum.";
}
else
{
	?>
	<form name="iform" id="iform" action="advancededit.php" method="POST">
	
	<input type="hidden" name="formstage" id="formstage" value="2" />
	<input type="hidden" name="fid" id="fid" value="<?php print $fid; ?>" />
	
	<table border="0" cellspacing="0" cellpadding="0">
	<?php
	foreach ( $eligibleinvites as $ekey => $eval )
	{
		if ( $ekey == 0 )
		{
			continue;
		}
		
		$subuser = array();
		$subuser = LoadUser( $eval["userid"] );
		
		if ( $subuser["email"] == NULL )
		{
			continue;
		}
		
		print "<tr><td>";
		print "<input type=\"checkbox\" name=\"inv";
		print $eval["userid"] . "\" id=\"inv";
		print $eval["userid"] . "\" value=\"1\" /> &nbsp;";
		print "</td><td>";
		print "<a href=\"viewprofile.php?userid=" . $eval["userid"] . "\">";
		print $eval["fullname"] . " (" . $subuser["email"] . ")";
		print "</a>";
		print "</td></tr>";
	}
	
	?>
	</table>
	
	<br />
	
	<input type="submit" name="submitform" value="Send Invitations" />
	
	</form>
	
	<?php
}

?>
</td>

<td bgcolor="#90EE90" valign="TOP">

<img src="images/space1px.gif" height="13" width="13"></td>

<td bgcolor="#90EE90"><img src="images/space1px.gif" width="8" height="1" /></td>

</tr>
</table>

</td>
</tr>

<tr>
<td></td>
<td>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td width="8"><img src="images/botleftb.gif" width="8" height="8" alt="" /></td>
<td bgcolor="#90EE90"><img src="images/space1px.gif" width="1" height="8" alt="" /></td>

<td width="11"><img src="images/botrightb.gif" width="11" height="8" alt="" /></td>
</tr>
</table>

</td>
</tr>

</table>

<?php
GenerateBottom();
GenerateFooter();
